/* ----------------------------------------------------------------------- *
 * G L S a m p l e 4 V i e w . h
 *
 * interface of the CGLSample4View class
 *
 * Copyright 1996 by Interface Technologies, Inc. All Rights Reserved.
 * GLSample4 Authored by N. Alan Oursland
 * ----------------------------------------------------------------------- */

class CGLSample4View : public CView
{
protected: // create from serialization only
	CPoint m_LDownPos;
	BOOL m_LButtonDown;
	HGLRC m_hGLContext;
	BOOL CreateViewGLContext(HDC hDC);
	int m_GLPixelIndex;
	BOOL SetWindowPixelFormat(HDC hDC);
	CGLSample4View();
	DECLARE_DYNCREATE(CGLSample4View)

// Attributes
public:
	CGLSample4Doc* GetDocument();

// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CGLSample4View)
	public:
	virtual void OnDraw(CDC* pDC);  // overridden to draw this view
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	protected:
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CGLSample4View();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:

// Generated message map functions
protected:
	//{{AFX_MSG(CGLSample4View)
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	afx_msg void OnDestroy();
	afx_msg void OnSize(UINT nType, int cx, int cy);
	afx_msg void OnPaint();
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnLButtonUp(UINT nFlags, CPoint point);
	afx_msg void OnMouseMove(UINT nFlags, CPoint point);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

#ifndef _DEBUG  // debug version in GLSample4View.cpp
inline CGLSample4Doc* CGLSample4View::GetDocument()
   { return (CGLSample4Doc*)m_pDocument; }
#endif

/////////////////////////////////////////////////////////////////////////////
