
'# an m4 macro, DEFINE_GUID, which defines a GUID global constant in 
'# the form used in c/c++; e.g.
'# DEFINE_GUID(CLSID_AMAudioData,0xf2468580,0xaf8a,0x11d0,0x82,0x12,0x00,0xc0,0x4f,0xc3,0x2c,0x45)

VERSION "0.0001"
CONSOLE

	IMPORT "xst"				' Standard library : required by most programs
	IMPORT "xsx"				' Extended standard library
  IMPORT "gdi32"			' gdi32.dll
	IMPORT "user32"		  ' user32.dll
	IMPORT "shell32"		' shell32.dll
	IMPORT "ole32.dec"

TYPE CONST_GUID
	UNION
		GUID .guid
		STRING *16 .gs
	END UNION
END TYPE

m4_define(`DEFINE_GUID', ``$$'$1` = "'_GUID1($2)`'_GUID2($3)`'_GUID2($4)`'_GUID3($5)`'_GUID3($6)`'_GUID3($7)`'_GUID3($8)`'_GUID3($9)`'_GUID3($10)`'_GUID3($11)`'_GUID3($12)"')
m4_define(`_GUID1', ``\x'm4_substr($1, 8, 2)`\x'm4_substr($1, 6, 2)`\x'm4_substr($1, 4, 2)`\x'm4_substr($1, 2, 2)')
m4_define(`_GUID2', ``\x'm4_substr($1, 4, 2)`\x'm4_substr($1, 2, 2)')
m4_define(`_GUID3', ``\'m4_substr($1,1,3)')

'# the following can be replaced by using DEFINE_GUID macro
'# $$IID_IWebBrowser2 = "\x61\x16\x0C\xD3\xAF\xCD\xD0\x11\x8A\x3E\x00\xC0\x4F\xC9\xE2\x6E"

DEFINE_GUID(IID_IWebBrowser2,0xD30C1661,0xCDAF,0x11D0,0x8A,0x3E,0x00,0xC0,0x4F,0xC9,0xE2,0x6E)

DECLARE FUNCTION Entry ()

FUNCTION Entry ()

CONST_GUID iid

	iid.gs = $$IID_IWebBrowser2

	PRINT HEXX$(iid.guid.data1), HEXX$(iid.guid.data2), HEXX$(iid.guid.data3)
	FOR i = 0 TO 7
		PRINT HEXX$(iid.guid.data4[i]),
	NEXT i

	?

  a$ = INLINE$ ("Press Enter to quit >")

END FUNCTION

END PROGRAM